var delay = (function(){
  var timer = 0;
  return function(callback, ms){
    clearTimeout (timer);
    timer = setTimeout(callback, ms);
  };
})();

$(function(){
	$('#invoice').tooltip({
		selector: '[rel=tooltip]',
		container: 'body'
	});
	var RowCommands = '<div style="display:none;" class="rowcommands"><div class="move" title="Drag to reorder"></div><div class="add" title="Insert row"></div><div class="delete" title="Remove row"></div></div>';
	
	var ItemsRow = '<tr><td>'+RowCommands+'</td><td><textarea class="itemname" rows="1" cols="1" rel="tooltip" data-original-title="Enter item description" placeholder="Product you\'re selling" maxlength="300"></textarea></td><td><input class="quantity" type="text" rel="tooltip" data-original-title="Enter quantity" placeholder="Quantity" maxlength="15" /></td><td><input class="price" type="text" rel="tooltip" data-original-title="Enter price" placeholder="Price" maxlength="15" /></td><td><span class="linetotal"></span></td></tr>';
	
	
	Calculate = function() {
		var total = 0, subtotal = 0;
		
		$('#items_table tr').each(function(index, el) {
			var qty = parseFloat($(el).find('.quantity').val());
			var pri = parseFloat($(el).find('.price').val());
			
			var res = 0;
			if(!isNaN(qty) && !isNaN(pri))
				res = parseFloat(qty * pri).toFixed(2);
			
			if(!isNaN(res))
			{
	        	$(el).find('.linetotal').html(res);
				subtotal += parseFloat(res);
			}
        });
		
		var tax = $('#taxsum').val().replace(/[^0-9.]/gi, '');
		tax = parseFloat(tax) / 100;
		
		if(!isNaN(tax))
			tax = subtotal * tax;
		else
			tax = 0;
		
		total = subtotal + tax;
		
		$('#subtotalsumvalue').html(subtotal.toFixed(2));
		
		$('#taxsumvalue').html(tax.toFixed(2));
		
		$('#totalsumvalue').html(total.toFixed(2));
	}
	
	AddRow = function(e) {
		if(e)
		{
			e.stopPropagation();
			e.preventDefault();
		}
		if($('#items_table tr').length < 10)
		{
			if(!$(this).hasClass('addlink'))
				$(this).parents('tr').before($(ItemsRow));
			else
				$('#items_table').append($(ItemsRow));
		}
		else
		{
			$(window.parent)[0].$('#maxrows').modal('show');
		}
		
		InitInvoice();
		
		SaveInvoice();
		
		InitItemsTable();
	};

	DeleteRow = function(e) {
		e.stopPropagation();
		e.preventDefault();
		$(this).parents('tr').remove();
		
		SaveInvoice();
		
		InitItemsTable();
	}
	
	HoverIn = function(e) {
		$(this).find('.rowcommands').show();
	}
	
	HoverOut = function(e) {
		$(this).find('.rowcommands').hide();
	}
	
	$('.addrowlink a').click(AddRow);
	
	LoadInvoice = function() {
		if(localStorage)
		{
			var d = new Date();
			var data =
			{
				"logo_img": "",
				"company_name": "Dino Store",
				"company_address_contact": "227 Cobblestone Road | 30000 Bedrock, Cobblestone County\nhttp://dinostore.bed | hello@dinostore.bed",
				"title": "INVOICE",
				"number": "#INV-001",
				"billtolabel": "Client:",
				"clientname": "Fred Flint",
				"clientinfo": "222 Rocky Way\n30000 Bedrock, Cobblestone County\nfred@flintstone.bed",
				"issuedatelabel": "Issue date:",
				"issuedate": (d.getMonth() + 1) + "/" + d.getDate() + "/" + d.getFullYear(),
				"netdayslabel": "Net days:",
				"netdays": "21",
				"currencylabel": "Currency:",
				"currency": "USD",
				"ponumberlabel": "P.O.",
				"ponumber": "33/200-4",
				"itemlabel": "Item & Description",
				"quantitylabel": "Quantity",
				"pricelabel": "Price",
				"linetotallabel": "Linetotal",
				"subtotalsum": "SUBTOTAL",
				"taxsum": "TAX 10%",
				"totalsum": "TOTAL",
				"noteslabel": "Notes:",
				"termsnotesvalue": "Fred, thank you very much.  We really appreciate your business.",
				"items": [{"itemname":"Frozen Brontosaurus Ribs","quantity":"4","price":"100"},{"itemname":"Mammoth Chops","quantity":"2","price":"170"}]
			};
			
			if(localStorage["invoice_data"]) {
				data = JSON.parse(localStorage["invoice_data"]);
			}
			
			$('input, textarea').each(function(index, element) {
				var el = $(element);
				if(el.attr('id') != undefined)
				{
					$('#' + el.attr('id')).val(data[el.attr('id')]);
				}
			});
			
			for(var i = 0; i < data.items.length; i++)
			{
				$('#items_table').append($(ItemsRow));
				InitInvoice();
				
				var row = $('#items_table tr:nth-child('+(i+1)+')');
				row.find('.itemname').val(data.items[i]["itemname"]);
				row.find('.quantity').val(data.items[i]["quantity"]);
				row.find('.price').val(data.items[i]["price"]);
			}
			
			if(data["logo_img"] != '' && data["logo_img"] != undefined)
			{
				$('#logo_img').attr('src', data["logo_img"]).show();
				$('#drop_text').hide();
			}
			
			Calculate();
			
			setTimeout(function() {
				try {
					window.parent.$('#savestatus').text('');
				}
				catch(err) { }
			}, 500);
		}
	}
	
	InitItemsTable = function() {
		try {
			new TableDnD().init(document.getElementById('items_table'));
		}
		catch(err) { }
	}
	
	InitInvoice = function()
	{
		// first remove old keyup handler
		$('input, textarea').off('keyup');
		
		$('#items_table tr td:first-child').html($(RowCommands));
		
		$('#items_table .add').click(AddRow);
		
		$('#items_table .delete').click(DeleteRow);
		
		$('#items_table tr').hover(HoverIn, HoverOut);
		
		$('#taxsum').keyup(function(e) {
            Calculate();
        });
		
		$('.quantity, .price').keyup(function(e) {
			Calculate();
		})
		.keydown(function (e) { // allow only numbers
			if (e.ctrlKey)
				return true;
	
			if ((e.keyCode >= 35 && e.keyCode <= 40) || 
					((e.keyCode >= 48 && e.keyCode <= 57) && !e.shiftKey) || 
					(e.keyCode >= 96 && e.keyCode <= 105) || 
					e.keyCode == 8 || e.keyCode == 9 || 
					e.keyCode == 46 || e.keyCode == 190 || 
					e.keyCode == 116) {
					// Don't do anything
			} else {
				e.preventDefault();
			}
			if($(this).val().indexOf('.') != -1 && event.keyCode == 190)
				e.preventDefault(); 
		});

		$('input, textarea').keyup(function() {
			delay(function(){
			  SaveInvoice();
			}, 1000);
		});

	}

	SaveInvoice = function() {
		if(localStorage)
		{
			window.parent.$('#savestatus').text('Saving all changes ...');
			var data = {};
			var tax = $('#taxsum').val().replace(/[^0-9.]/gi, '');
			tax = parseFloat(tax) / 100;
			$('input, textarea').each(function(index, element) {
				var el = $(element);
				if(el.attr('id') != undefined)
				{
					data[el.attr('id')] = el.val();
				}
			});
			
			items = [];
			$('#items_table tr').each(function(index, element) {
				var el = $(element);
				var linetotal = parseFloat(el.find('.quantity').val()*el.find('.price').val()).toFixed(2);
				var row = { "itemname": el.find('.itemname').val(), "quantity": el.find('.quantity').val(), "price": el.find('.price').val(),"linetotal": linetotal };
				items.push(row);
			});
			
			data['items'] = items;
			data['tax'] = tax;
			data["logo_img"] = $('#logo_img').attr('src');
			
			localStorage["invoice_data"] = JSON.stringify(data);
			
			setTimeout(function() {
				try {
					window.parent.$('#savestatus').text('');
				}
				catch (err) { }
			}, 500);
		}
	}
		
	handleFileSelect = function(e) {
		e.stopPropagation();
		e.preventDefault();
	
		var files = e.originalEvent.dataTransfer.files; // FileList object.	
		var file = files[0];

		if(!file.type.match(/image.*/))
		{
			alert('Please upload image file. Supported formats are .png, .jpg ang .gif');
			return;
		}
		if(file.size > 1048576)
		{
			alert('File too big, maximum size is 1MB');
			return;
		}
		
		var img = new Image();
		var reader = new FileReader();
		reader.onload = function(e) { img.src = e.target.result; }
		
		img.onload = function(e) {
			var MAX_WIDTH = 200;
			var MAX_HEIGHT = 100;
			var width = img.width;
			var height = img.height;
			
			if (width > height) {
				if (width > MAX_WIDTH) {
					height *= MAX_WIDTH / width;
					width = MAX_WIDTH;
				}
				if (height > MAX_HEIGHT) {
					width *= MAX_HEIGHT / height;
					height = MAX_HEIGHT;
				}
			} else {
				if (width > MAX_WIDTH) {
					height *= MAX_WIDTH / width;
					width = MAX_WIDTH;
				}
				if (height > MAX_HEIGHT) {
					width *= MAX_HEIGHT / height;
					height = MAX_HEIGHT;
				}
			}
			if(width < 1) width = 1;
			if(height < 1) height = 1;
			
			var canvas = document.createElement('canvas');
			canvas.width = width;
			canvas.height = height;

			var ctx = canvas.getContext("2d");
			ctx.drawImage(img, 0, 0, width, height);
			
			var dataurl = canvas.toDataURL("image/png");
			
			$('#logo_img').attr('src', dataurl).hide().fadeIn();
			
			$('#drop_text').hide();
			
			SaveInvoice();
		};

		reader.readAsDataURL(file);
		
		$('#drop_zone').removeClass('borderHover');
	}
	
	RemoveLogo = function() {
		$('#logo_img').attr('src', '').hide();
		$('.remove_logo').remove();
		$('#drop_text').show();
		
		SaveInvoice();
	}
	
	$('#drop_zone').hover(
		function() {
			if($('#logo_img').is(':visible'))
				$('#drop_zone').append($('<img src="images/remove.png" onclick="RemoveLogo()" class="remove_logo" title="Remove logo" />'));
				
		},
		function() {
			$('.remove_logo').remove();
		}
	)
	
	$(document).bind('drop dragover', function (e) {
		e.stopPropagation();
		e.preventDefault();
		
		e.originalEvent.dataTransfer.dropEffect = 'none';
	});
	
	handleDragOver = function(e) {
		e.stopPropagation();
		e.preventDefault();
		
		e.originalEvent.dataTransfer.dropEffect = 'copy'; // Explicitly show this is a copy.
	}
	
	handleDragEnter = function(e) {
		e.stopPropagation();
		e.preventDefault();

		$('#drop_zone').addClass('borderHover');
	}
	
	handleDragLeave = function(e) {
	  	e.stopPropagation();
	  	e.preventDefault();

		$('#drop_zone').removeClass('borderHover');
	}
	
	// Setup the dnd listeners.
	$('#drop_zone').bind('dragenter', handleDragEnter);
	$('#drop_zone').bind('dragleave', handleDragLeave);
	$('#drop_zone').bind('dragover', handleDragOver);
	$('#drop_zone').bind('drop', handleFileSelect);
	
	InitInvoice();
	
	LoadInvoice();
		
	InitItemsTable();
	
	
});