(function () {

  function createCookie(name, value, expires, path, domain) {
    var cookie = name + '=' + escape(value) + ';';
   
    if (expires) {
      // If it's a date
      if(expires instanceof Date) {
        // If it isn't a valid date
        if (isNaN(expires.getTime()))
         expires = new Date();
      }
      else
        expires = new Date(new Date().getTime() + parseInt(expires) * 1000 * 60 * 60 * 24);
   
      cookie += 'expires=' + expires.toGMTString() + ';';
    }
   
    if (path)
      cookie += 'path=' + path + ';';
    if (domain)
      cookie += 'domain=' + domain + ';';
   
    document.cookie = cookie;
  }

  function getCookie(name) {
    var cname = name + '=';
    var ca = document.cookie.split(';');

    for(var i = 0; i < ca.length; i++) {
      var c = ca[i];

      while (c.charAt(0) == ' ')
        c = c.substring(1);

      if (c.indexOf(cname) === 0)
        return unescape(c.substring(cname.length, c.length));
    }
    return '';
  }

  function getParameterByName(name) {
    name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
    var regex = new RegExp('[\\?&]' + name + '=([^&#]*)'),
        results = regex.exec(location.search);
    return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
  }

  var affiliate_code = getParameterByName('aff');

  // Only track if it isn't stoped (usually after user signup)
  if(!getCookie('_ib_aff_stop'))
  {
    // Only write the cookies if there's an new affiliate code in the URL
    if(affiliate_code && affiliate_code !== getCookie('_ib_aff_code'))
    {
      createCookie('_ib_aff_code', affiliate_code, 180, '/', '.invoicebus.com');
      createCookie('_ib_aff_uid', (Date.now() + Math.random()).toString(36), 180, '/', '.invoicebus.com');
    }

    if(getCookie('_ib_aff_code') && getCookie('_ib_aff_uid'))
    {
      var js = document.createElement('script');
      js.async = true;
      document.body.appendChild(js);
      js.src = 'https://partners.invoicebus.com/magic.js' +
               '?rand=' + Math.random(); // To prevent caching
    }
  }

})();
